using System;

public class BooleanIConvertibleToInt64
{

    public static int Main()
    {
        BooleanIConvertibleToInt64 testCase = new BooleanIConvertibleToInt64();

        TestLibrary.TestFramework.BeginTestCase("Boolean.IConvertible.ToInt64");
        if (testCase.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }

    public bool RunTests()
    {
        bool retVal = true;

        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;
        retVal = PosTest2() && retVal;


        return retVal;
    }

    public bool PosTest1()
    {
        bool retVal = true;
        try
        {
            if ( (true as IConvertible).ToInt64(null) != 1L)
            {
                TestLibrary.TestFramework.LogError("001", "expect (true as IConvertible).ToInt64(null) == 1L");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("001", "Unexpected exception: " + e);
            retVal = false;
        }
        return retVal;
    }

    public bool PosTest2()
    {
        bool retVal = true;
        try
        {
            if ( (false as IConvertible).ToInt64(null) != 0L )
            {
                TestLibrary.TestFramework.LogError("002", "expect (false as IConvertible).ToInt64(null) == 0L");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("002", "Unexpected exception: " + e);
            retVal = false;
        }
        return retVal;
    }

}
