using System;
/// <summary>
/// Convert.ToUInt16(Char)
/// </summary>
public class ConvertToUInt163
{
    public static int Main()
    {
        ConvertToUInt163 convertToUInt163 = new ConvertToUInt163();

        TestLibrary.TestFramework.BeginTestCase("ConvertToUInt163");
        if (convertToUInt163.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }
    public bool RunTests()
    {
        bool retVal = true;
        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;
        retVal = PosTest2() && retVal;
        retVal = PosTest3() && retVal;
        return retVal;
    }
    #region PositiveTest
    public bool PosTest1()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest1: Convert to UInt16 from Char 1");
        try
        {
            char charVal = char.MaxValue;
            ushort ushortVal = Convert.ToUInt16(charVal);
            if (ushortVal != (ushort)(charVal))
            {
                TestLibrary.TestFramework.LogError("001", "the ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("002", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    public bool PosTest2()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest2: Convert to UInt16 from Char 2");
        try
        {
            char charVal = char.MinValue;
            ushort ushortVal = Convert.ToUInt16(charVal);
            if (ushortVal != (ushort)(charVal))
            {
                TestLibrary.TestFramework.LogError("003", "the ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("004", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    public bool PosTest3()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest3: Convert to UInt16 from Char 3");
        try
        {
            char charVal = TestLibrary.Generator.GetChar(-55);
            ushort ushortVal = Convert.ToUInt16(charVal);
            if (ushortVal != (ushort)(charVal))
            {
                TestLibrary.TestFramework.LogError("005", "the ExpectResult is not the ActualResult");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("006", "Unexpect exception:" + e);
            retVal = false;
        }
        return retVal;
    }
    #endregion
}
