using System;

/// <summary>
/// GetHashCode
/// </summary>

public class DoubleGetHashCode
{
    #region Public Methods
    public bool RunTests()
    {
        bool retVal = true;

        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;  
        
        return retVal;
    }

    #region Positive Test Cases
    public bool PosTest1()
    {
        bool retVal = true;

        TestLibrary.TestFramework.BeginScenario("PosTest1: check that if the return value is equal.");

        try
        {
            Double i = TestLibrary.Generator.GetDouble(-55);
            Double i1 = i;
            Double i2 = i;

            if (i1.GetHashCode() != i2.GetHashCode())
            {
                TestLibrary.TestFramework.LogError("001.1", "gethashcode is not equal  : " + i1);
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("001.2", "Unexpected exception: " + e);
            retVal = false;
        }

        return retVal;
    }
    #endregion

    #endregion

    public static int Main()
    {
        DoubleGetHashCode test = new DoubleGetHashCode();

        TestLibrary.TestFramework.BeginTestCase("DoubleGetHashCode");

        if (test.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }
}
