using System;
using System.Collections;

/// <summary>
/// System.Math.Max(System.Decimal,System.Decimal)
/// </summary>
public class MathMax2
{
    public static int Main(string[] args)
    {
        MathMax2 max2 = new MathMax2();
        TestLibrary.TestFramework.BeginTestCase("Testing System.Math.Max(System.Decimal,System.Decimal)...");

        if (max2.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }

    public bool RunTests()
    {
        bool retVal = true;

        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;

        return retVal;
    }

    public bool PosTest1()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest1: Verify the return value of max function...");

        try
        {
            double dVar1 = TestLibrary.Generator.GetDouble(-55);
            decimal var1 = new decimal(dVar1);
            double dVar2 = TestLibrary.Generator.GetDouble(-55);
            decimal var2 = new decimal(dVar2);

            if (decimal.Compare(var1, var2) < 0)
            {
                if (Math.Max(var1, var2) != var2)
                {
                    TestLibrary.TestFramework.LogError("001", "the max value should be var2!");
                    retVal = false;
                }
            }
            else
            {
                if (Math.Max(var1, var2) != var1)
                {
                    TestLibrary.TestFramework.LogError("002","The max value should be var1!");
                    retVal = false;
                }
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("003","Unexpected exception occurs: " + e);
            retVal = false;
        }

        return retVal;
    }
}
