using System;
using System.Collections;

/// <summary>
/// System.Math.PI
/// </summary>
public class MathPI
{
    public static int Main(string[] args)
    {
        MathPI mathPI = new MathPI();
        TestLibrary.TestFramework.BeginTestCase("Testing System.Math.PI...");

        if (mathPI.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }

    public bool RunTests()
    {
        bool retVal = true;

        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;

        return retVal;
    }

    public bool PosTest1()
    {
        bool retVal = true;
        TestLibrary.TestFramework.BeginScenario("PosTest2: Verify the value of Math.PI...");

        try
        {
            double mathPI = Math.PI;
            if (mathPI != 3.1415926535897931)
            {
                TestLibrary.TestFramework.LogError("001","The value of Math.PI is not correct!");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("002","Unexpected exception occurs: " + e);
            retVal = false;
        }

        return retVal;
    }
}
