using System;

public class ObjectCtor
{
    #region Public Method
    public bool RunTests()
    {
        bool retVal = true;

        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;
        retVal = PosTest2() && retVal;

        return retVal;
    }

    #region Positive Test Cases
    public bool PosTest1()
    {
        bool retVal = true;

        TestLibrary.TestFramework.BeginScenario("PosTest1: Create a new Object instance");

        try
        {
            Object obj = new Object();

            if (null == obj)
            {
                TestLibrary.TestFramework.LogError("001", "Failed to instance a Object type");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("002", "Unexpected exception: " + e);
            TestLibrary.TestFramework.LogInformation(e.StackTrace);
            retVal = false;
        }

        return retVal;
    }

    public bool PosTest2()
    {
        bool retVal = true;

        TestLibrary.TestFramework.BeginScenario("PosTest2: Create two Object instances, make sure CLR does not use the memory occuppied by the first one to alloc the second one");

        try
        {
            Object obj1 = new Object();
            Object obj2 = new Object();

            if (Object.ReferenceEquals(obj1, obj2))
            {
                TestLibrary.TestFramework.LogError("003", "CLR uses the memory occuppied by the first one to alloc the second one");
                retVal = false;
            }
        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("004", "Unexpected exception: " + e);
            TestLibrary.TestFramework.LogInformation(e.StackTrace);
            retVal = false;
        }

        return retVal;
    }
    #endregion
    #endregion

    public static int Main()
    {
        ObjectCtor oc = new ObjectCtor();

        TestLibrary.TestFramework.BeginTestCase("ObjectCtor");

        if (oc.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }
}
