using System;
using System.Text;

/// <summary>
/// GetMaxCharCount(System.Int32) [v-jianq]
/// </summary>

public class UTF8EncodingGetMaxCharCount
{
    #region Public Methods
    public bool RunTests()
    {
        bool retVal = true;

        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;
        
        //
        // TODO: Add your negative test cases here
        //
        // TestLibrary.TestFramework.LogInformation("[Negative]");
        retVal = NegTest1() && retVal;

        return retVal;
    }

    #region Positive Test Cases
    public bool PosTest1()
    {
        bool retVal = true;

        // Add your scenario description here
        TestLibrary.TestFramework.BeginScenario("PosTest1: Verify method GetMaxCharCount");

        try
        {
            UTF8Encoding utf8 = new UTF8Encoding();
            int byteCount = 8;
            int maxCharCount = utf8.GetMaxCharCount(byteCount);

        }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("001", "Unexpected exception: " + e);
            TestLibrary.TestFramework.LogInformation(e.StackTrace);
            retVal = false;
        }

        return retVal;
    }
    #endregion

    #region Nagetive Test Cases
    public bool NegTest1()
    {
        bool retVal = true;

        TestLibrary.TestFramework.BeginScenario("NegTest1: ArgumentOutOfRangeException is not thrown when byteCount is less than zero.");

        try
        {
            UTF8Encoding utf8 = new UTF8Encoding();
            int byteCount = -1;
            int maxCharCount = utf8.GetMaxCharCount(byteCount);

            TestLibrary.TestFramework.LogError("101.1", "ArgumentOutOfRangeException is not thrown when byteCount is less than zero.");
            retVal = false;
        }
        catch (ArgumentOutOfRangeException) { }
        catch (Exception e)
        {
            TestLibrary.TestFramework.LogError("101.2", "Unexpected exception: " + e);
            TestLibrary.TestFramework.LogInformation(e.StackTrace);
            retVal = false;
        }

        return retVal;
    }
    #endregion
    #endregion

    public static int Main()
    {
        UTF8EncodingGetMaxCharCount test = new UTF8EncodingGetMaxCharCount();

        TestLibrary.TestFramework.BeginTestCase("UTF8EncodingGetMaxCharCount");

        if (test.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }
}
