using System;

/// <summary>
/// UIntPtr.Size
/// Gets the size of this instance. 
/// This field is not CLS-compliant.  
/// </summary>
public class UIntPtrSize
{
    public static int Main()
    {
        UIntPtrSize testObj = new UIntPtrSize();

        TestLibrary.TestFramework.BeginTestCase("for property: UIntPtr.Size");
        if(testObj.RunTests())
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("PASS");
            return 100;
        }
        else
        {
            TestLibrary.TestFramework.EndTestCase();
            TestLibrary.TestFramework.LogInformation("FAIL");
            return 0;
        }
    }

    public bool RunTests()
    {
        bool retVal = true;

        TestLibrary.TestFramework.LogInformation("[Positive]");
        retVal = PosTest1() && retVal;

        return retVal;
    }


    [System.Security.SecuritySafeCritical]
    public unsafe bool PosTest1()
    {
        bool retVal = true;

        const string c_TEST_ID = "P001";
        const string c_TEST_DESC = "PosTest1: UIntPtr.Size is platform specified";
        string errorDesc;

        bool actualResult;

        TestLibrary.TestFramework.BeginScenario(c_TEST_DESC);
        try
        {
            int expectedSize = sizeof(void *);
            actualResult = UIntPtr.Size == expectedSize;
            if (!actualResult)
            {
                errorDesc = "The size of UIntSize should be " + expectedSize;
                TestLibrary.TestFramework.LogError("001" + " TestId-" + c_TEST_ID, errorDesc);
                retVal = false;
            }
        }
        catch (Exception e)
        {
            errorDesc = "Unexpected exception: " + e;
            TestLibrary.TestFramework.LogError("002" + " TestId-" + c_TEST_ID, errorDesc);
            retVal = false;
        }

        return retVal;
    }
}

