// Copyright (c) Microsoft. All rights reserved.
// Licensed under the MIT license. See LICENSE file in the project root for full license information.
//

using System.Runtime.CompilerServices;
using System;

class SpAddr
{

    // Struct in reg (2 ints)
    struct S
    {
        public int i0;
        public int i1;
    }

    [MethodImpl(MethodImplOptions.NoInlining)]
    static int Foo(S s0, S s1)
    {
        // Console.WriteLine("s0 = [{0}, {1}], s1 = [{2}, {3}]", s0.i0, s0.i1, s1.i0, s1.i1);
        return s0.i0 + s0.i1 + s1.i0 + s1.i1;
    }

    [MethodImpl(MethodImplOptions.NoInlining)]
    static int M(int i0, int i1, int i2, int i3)
    {
        S s0;
        s0.i0 = i1;
        s0.i1 = i0;
        S s1;
        s1.i0 = i2;
        s1.i1 = i3;
        return Foo(s0, s1); // r0 <= r1; r1 <= r0; r2 <= r3; r3 <= r2
    }

    public static int Main(String[] args)
    {
        int res = M(1, 2, 3, 4);
        Console.WriteLine("M(1, 2, 3, 4) is {0}.", res);
        if (res == 10)
            return 100;
        else
            return 99;
    }
}
